DEBUG equ 0

debug_rva equ 0dea6h

.code

re_fix_calls:
; lib id stuff
;100445C0 mov     eax, [esp+arg_0]
;100445C4 mov     ecx, dword_10065210
;100445CA lea     eax, [eax+eax*2]
;100445CD mov     al, [ecx+eax*2+2]
;100445D1 and     eax, 1
;100445D4 retn

; build lib id table for that little extra demangling
    pushad
    xor eax, eax
    lea edi, lib_id
    mov esi, [lib_id_ptr]
    add esi, [stxt774_offset]
    add esi, [memory_ptr]
 lib_id_loop:
;    inc eax
    lea ebx, [eax+eax*2]
;    dec eax
    mov bl, [esi+ebx*2+2]
    and ebx, 1
    test ebx, ebx
    jz over_store_id
    stosd
 over_store_id:
    inc eax
    cmp eax, 40h
    jnz lib_id_loop
    popad

    mov ecx, [pe_sections]
    sub ecx, 2
    mov esi, [sections_ptr]

next_section:
    push esi
    push ecx


more_stuff_to_fix:
    mov ebx, [esi+14h]  ; raw offset
    mov edx, [esi+10h]  ; section's RAW size
    mov [re_temp_offset], ebx
    add dword ptr [re_temp_offset], 2
rfc_size_ok:
    mov ecx, dword ptr [esi+14h]       ; section's RAW offset
    add ecx, dword ptr [memory_ptr]    ; ecx points to beginning of section
    mov esi, ecx

    add edx, ebx       ; edx == raw offset+raw size of section
    add ebx, 2
    add ecx, 2
    sub edx, 4

rfc_scan_next_byte:
    inc esi
    mov eax, esi
    sub eax, [memory_ptr]   ; eax raw offset to byte
    cmp eax, edx            ; check its lower than the size of this section
    jl  rfc_check_ff15
rfc_get_next_section:
    pop ecx
    pop esi
    add esi, 28h          ; prep esi so it points to next decrypted section
    dec ecx
    jne next_section
    ret

rfc_check_ff15:
    sub eax, ebx    ; eax == raw offset in section

    IF DEBUG
    cmp ebx, debug_rva
    jnz over_di3
    int 3
    over_di3:
    ENDIF
    
    add ebx, eax
    add ecx, eax
    cmp word ptr [ecx-02], 15FFh    ; do we have a CALL DWORD PTR ?
    jne rfc_scan_next_byte

; decide whether or not the call needs fixing
    push edx
    push ecx
    mov eax, ebx
    sub eax, dword ptr [re_temp_offset]      ; eax == raw offset relative to section
    xor edx, edx

raxs_api_stuff:

    mov     ecx, eax            ; make a copy of the calling address
    lea     edx, raxs_proc
    add     edx, 115h
    call    edx                     ; morph it
    xor     eax, ecx                ; xor encrypted, original
    mov     ecx, eax                ; copy encrypted & xor'ed address
    sub     edx, 115h
    call    edx                     ; morph it again
    xor     edx, edx
    xor     eax, ecx                ; xor again
    mov     ecx, 4                  ; then do simple maths
    div     ecx                     ; to see if we should fix
    mov     eax, edx                ; the calling address
    pop     ecx
    pop     edx
    cmp     eax, 2
    jae     rfc_scan_next_byte

decide_which_library:
; kernel or user api to be fixed?
    mov edi, 40h
    mov eax, [ecx]                  ; ecx -> pointer to api
    sub eax, [pe_image_base]
blubb1:
    sub edi, 04h
    cmp edi, -04h
    je rfc_scan_next_byte
    cmp dword ptr [begin_thunk+edi], 0
    jz blubb1
    cmp eax, [begin_thunk+edi]   ; was the call to a wrapped api?
    jl blubb1
    cmp eax, [end_thunk+edi]
    ja blubb1

    mov [temp_lib_id], edi
    shr [temp_lib_id], 2

; calculate the real api that it should be calling
; using decrypt_key & raw offset of call relative to the section its calling from
    sub eax, [begin_thunk+edi]
    shr eax, 02

    call check_if_call_mangled
    jz rfc_scan_next_byte

ret_here:
    push edx
    push ecx
    push eax
    mov ecx, [end_thunk+edi]
    sub ecx, [begin_thunk+edi]
    shr ecx, 02
    mov eax, ebx
    sub eax, dword ptr [re_temp_offset]
    add eax, [decrypt_key]
    xor edx, edx
    div ecx
    pop eax
    sub eax, edx
    xor edx, edx
    add eax, ecx
    div ecx
    mov eax, edx
    pop ecx
    pop edx

    pushad
    push    eax
    mov     ecx, eax
    shr     ecx, 3

    lea     edi, lib_id
    mov     edx, [temp_lib_id]
    mov     edx, [edx*4+edi]

    lea     eax, stxt774_inf
    mov     edx, [eax+edx*4]
    add     edx, [stxt774_offset]
    add     edx, [memory_ptr]
    xor     eax, eax
    mov     al, [edx+ecx]
    ;test    al, al
    ;jz this_one_ok
    mov     ecx, [esp]
    and     ecx, 7
    mov     edx, 1
    shl     edx, cl
    and     eax, edx
    test    eax, eax
    jnz     this_one_ok

    add esp, 4
    popad
    ;test    eax, eax
    ;jz      oops_this_one_IS_ok
    jmp     ret_here
    
    db 'deal with it proper ;-)',0

 this_one_ok:
    add esp, 4
    popad
oops_this_one_IS_ok:
    shl eax, 02
    add eax, [begin_thunk+edi]
    add eax, [pe_image_base]
    mov dword ptr [ecx], eax
    jmp rfc_scan_next_byte


check_if_call_mangled:
    pushad
    push eax
    mov     ecx, eax
    shr     ecx, 3

    lea     edi, lib_id
    mov     edx, [temp_lib_id]
    mov     edx, [edx*4+edi]

    lea     eax, stxt774_inf
    mov     edx, [eax+edx*4]
    add     edx, [stxt774_offset]
    add     edx, [memory_ptr]
    movzx   eax, byte ptr [edx+ecx]
    mov     ecx, [esp]
    and     ecx, 7
    mov     edx, 1
    shl     edx, cl
    and     eax, edx
    pop ebx
    test    eax, eax
    popad
    ret
