
; dodgy safedisc v2.30.30 dump rebuilder..
; r!sc, 05/01

; 4010 patches, july 01..

.386P
.MODEL FLAT, STDCALL

o equ offset

extern CreateFileA:PROC
extern VirtualAlloc:PROC
extern VirtualFree:PROC
extern GetFileSize:PROC
extern CloseHandle:PROC
extern ReadFile:PROC
extern WriteFile:PROC
extern MessageBoxA:PROC
extern GetOpenFileNameA:PROC
extern ExitProcess:PROC
extern GetTickCount:PROC


.code
include fix_calls.asm
include decrypt_thunk_2a200.asm
include asciiz_decrypt_10029CD0.asm

randomize:
    pushad
    call GetTickCount
    xor ebx, eax
    rol eax, cl
    add ebx, eax
    xor [seed], ebx
    popad
    ret
    
main:
    call    randomize
    
    call    GetOpenFileNameA, offset ofn
    test    eax,eax
    je      clean_up_and_exit
    
    call    CreateFileA, offset icd_name, 80000000h, 0, 0, 3, 80h, 0
    cmp     eax, 0FFFFFFFFh
    je      icd_open_error
    mov     dword ptr [filehandle], eax

    call    GetFileSize, eax, 0
    mov     [icd_size], eax
    add     eax, 10000h
    and     eax, 3fff0000h    
    mov     dword ptr [memory_size], eax
    
; allocate some memory
    push    4       ; PAGE_READWRITE
    push    1000h   ; MEM_COMMIT
    push    eax     ; size of region 
    push    0       ;)
    call    VirtualAlloc
    mov     [memory_ptr], eax
    test    eax, eax
    je      mem_alloc_error
    
; read icd into memory
    push    0
    push    offset bytesrw
    push    [icd_size]
    push    eax
    push    [filehandle]
    call    ReadFile    
    push    [filehandle]
    call    CloseHandle
    mov     eax, [icd_size]
    cmp     [bytesrw], eax
    jne     read_icd_error

; uhm, check pe header is a pe header    
    mov     esi, dword ptr [memory_ptr]
    mov     ebx, esi
    add     ebx, dword ptr [icd_size]
    sub     ebx, 4

    cmp     word ptr [esi], 5a4dh   ; 'MZ'
    jne     pe_struct_error
    add     esi, dword ptr [esi+3ch]
    cmp     esi, ebx
    ja      pe_struct_error
    
    cmp     dword ptr [esi], 00004550h  ; 'PE',0,0
    jne     pe_struct_error
    mov     dword ptr [pe_header_ptr], esi

; and borrow some info, ptr to sections, rva of import table
    mov     edi, [esi+54h]      ; size of header's
    add     edi, [memory_ptr]
    movzx   ecx, word ptr [esi+6] ; NumberOfSections
    mov     [pe_sections], ecx
    mov     eax, [esi+34h]      ; ImageBase
    mov     [pe_image_base], eax
    add     eax, [esi+28h]      ; entrypoint
    mov     [icd_entrypoint], eax
    mov     eax, [esi+80h]      ;)
    mov     [import_ptr], eax
    xor     eax, eax
    mov     [esi+0d8h], eax
    mov     [esi+0dch], eax
    
    add     esi, 0f8h           ; beginning of pe sections
    mov     [sections_ptr], esi

    mov     esi, [memory_ptr]
    mov     edi, [pe_header_ptr]
    mov     eax, 28h
    imul    [pe_sections]
    sub     eax, 28h

    mov     ebx, [eax+edi+0f8h+0ch-28h]
    mov     [stxt774_rva], ebx
    mov     ebx, [eax+edi+0f8h+08h-28h]
    mov     [stxt774_vsize], ebx
    mov     ebx, [eax+edi+0f8h+14h-28h]
    mov     [stxt774_offset], ebx
    

    mov     ebx, [eax+edi+0f8h+14h] ; last sections raw offset
    add     ebx, [eax+edi+0f8h+10h] ; last sections raw size
    add     esi, ebx

;decrypt_key     dd 4 dup (?)
;                dd 100h dup (?) ; 1024 byte decrypt key
;raxs_proc       db 120h*2 dup (?)   ; api raxs proc (fix_calls)
;api_ptrs        dd 10h dup (?)      ; missing api ptrs from each thunk
;jmp_array       dd 100h dup (?)     ; :p
;stxt774_inf     dd 100h dup (?)     ; bunch of pointers into stxt774 section, used in api unwrapper
;lib_id_ptr      dd  ?               ; woohoo
    
    lea     edi, decrypt_key
    mov     ecx, 10h + 400h + 120h*2 + 40h + 400h + 400h + 4
    repz movsb

    mov     eax, [stxt774_rva]
    cmp     [jmp_array], eax
    jnz     jmp_err

    ;int 3
    lea     edi, stxt774_inf
    mov     ebx, [stxt774_rva]
    add     ebx, [pe_image_base]
    mov     ecx, 100h
fix_stxt774_inf:
    sub     [edi], ebx
    add     edi, 4
    dec     ecx
    jnz     fix_stxt774_inf

    sub     [lib_id_ptr], ebx

    call    decrypt_asciiz

    call    decrypt_mangled_api
       
    call    re_fix_calls

    mov esi, [sections_ptr]
    mov ebx, [esi+14h]  ; raw offset
    mov edx, [esi+0ch]  ; rva
    add ebx, [memory_ptr]
    sub ebx, edx


    xor edx, edx
    mov eax, [stxt774_vsize]
    sub eax, 8
    mov ecx, 1dh
    div ecx
    
    mov ebp, [stxt774_rva]
    add ebp, ebx
    
    mov edx, [pe_image_base]
    lea esi, jmp_array
    add esi, 4
stxt_jmp_loop:
    mov ecx, [esi]
    test ecx, ecx
    jz stxt_skip2
    add ecx, ebx
    cmp ecx, ebx
    jl stxt_skip
    jz stxt_skip
    cmp ecx, ebp
    ja stxt_skip
    
    
    cmp byte ptr [ecx-6], 0e9h
    jz jmp_fine
    cmp byte ptr [ecx-5], 0e9h
    jz call_j_fix
    pushad
    call    MessageBoxA, 0, o err_jmp_warning, offset error, 0
    popad
    jmp stxt_skip
jmp_fine:
    mov word ptr [ecx-6], 15ffh
    mov edi, [esi+4]
    add edi, edx
    mov dword ptr [ecx-4], edi
    stxt_skip:
    add esi, 8
    dec eax
    jnz stxt_jmp_loop
    jmp stxt_skip2

call_j_fix:
    ;int 3
    pushad
    mov eax, ebx
    sub eax, ecx
    mov ebx, [esi+4]
    add ebx, edx

    ;xor eax, eax
scan_dd_ptr:
    cmp [eax+ecx], ebx
    jz found_dd_ptr
    inc eax
    jmp scan_dd_ptr
found_dd_ptr:
    cmp word ptr [eax+ecx-2], 25ffh
    jz found_jmp_dd_ptr
    inc eax
    jmp scan_dd_ptr
found_jmp_dd_ptr:
    sub eax, 2
    mov byte ptr [ecx-5], 0e8h
    mov [ecx-4], eax
    popad
    jmp stxt_skip

stxt_skip2:
    mov     edi, [sections_ptr]
    mov     eax, 28h
    imul    [pe_sections]
    sub     ax, 50h
    add     edi, eax
    xor eax, eax
    mov ecx, 8
    repz stosd

    and     di, 0fff0h
    mov     ecx, 4
    lea     esi, evil_risc
    rand_:
    call    rand, 15
    cmp eax, tag_count
    ja rand_
    imul eax, 10h
    add esi, eax
    repz movsd
    mov ecx, 10h
    xor eax, eax
    repz stosd
   
    
    mov     esi, [pe_header_ptr]

    sub     word ptr [esi+6], 2
    
    mov     eax, 28h
    imul    [pe_sections]
    sub     eax, 50h+28h
    
    mov     ebx, [eax+esi+0f8h+0ch] ; last sections RVA
    add     ebx, [eax+esi+0f8h+08h] ; last sections vsize
    mov     [esi+50h], ebx          ; update imagesize (imagesize-=last two sections)
    
    mov     ebx, [eax+esi+0f8h+14h] ; last sections raw offset
    add     ebx, [eax+esi+0f8h+10h] ; last sections raw size (ebx = new raw file size)
    mov     [icd_size], ebx
    
ready_to_dump:
    mov     esi, [pe_header_ptr]
    mov     ebx, [esi+8]
    cmp     [esi+8], 00111900h
    jz      cfaD
    ;mov     [esi+8], '!NVD'
    call    CreateFileA, offset fileout_sdv2, 40000000h, 0, 0, 2, 80h, 0
    jmp write_file
cfaD:   ; createfileaDLL
    ;mov     [esi+8], '!NVD'
    call    CreateFileA, offset fileout_sdv2_dll, 40000000h, 0, 0, 2, 80h, 0
write_file:

    call    WriteFile, eax, [memory_ptr], [icd_size], offset bytesrw, 0, eax
    call    CloseHandle

    mov     esi, [pe_header_ptr]
    cmp     ebx, 00111900h
    jz      mbD
    call    MessageBoxA, 0, offset mbtitle, offset mbcaption, 0
    jmp clean_up_and_exit
    
    mbD:
    call    MessageBoxA, 0, offset mbtitleD, offset mbcaption, 0

clean_up_and_exit:
    call    VirtualFree, [memory_ptr], [memory_size], 8000h
    call    CloseHandle, [filehandle]
    call    ExitProcess, 0

exit_with_error:
    call    MessageBoxA, 0, eax, offset error, 0
    jmp     clean_up_and_exit
icd_open_error:
    mov     eax, o err_icd_open
    jmp     exit_with_error
pe_struct_error:
    mov     eax, o err_pe_struct
    jmp     exit_with_error
mem_alloc_error:
    mov     eax, o err_mem_alloc
    jmp     exit_with_error
read_icd_error:
    mov     eax, o err_read_icd
    jmp     exit_with_error
rand_err:
    mov     eax, o err_rand_err
    jmp     exit_with_error
jmp_err:
    mov     eax, o err_jmp_err
    jmp     exit_with_error
    
mbcaption db 'Criminal!',0
mbtitle   db 'sdv2.testme.exe created, please uhm, test it',0
mbtitleD  db 'sdv2.testme.dll created, please uhm, rename it & test it',0

evil_risc   db  '    suicide!    '
            db  '     nofear     '
            db  'street knowledge'
            db  ' hideous  kinky '
            db  '   spellbound   '
            db  '  r!sc woz ere  '
            db  '-razor 1911 rtl-'
            db  'can you feel it!'

tag_count equ 7 ; 0,1,2,3,4,5 tags ..

decrypt_asciiz:
    pushad
    lea     eax, api_ptr_inf
    mov     [temp_ptr], eax
    
    mov     eax, dword ptr [sections_ptr]    
    mov     edx, [import_ptr]           ; RVA of import info
scan4rdata:
    mov     ebx, dword ptr [eax+0ch]    ; RVA
    mov     ecx, dword ptr [eax+10h]    ; RAW size
    add     ecx, ebx
 
    cmp     edx, ecx
    jbe     is_rdata_this_section
    add     eax, 28h
    jmp     scan4rdata
is_rdata_this_section:
    cmp     edx, ebx
    jae     @onemorecheck
    add     eax, 28h
    jmp     scan4rdata
@onemorecheck:
    cmp     [eax+28h+0ch], edx
    jne     found_rdata_section
    add     eax, 28h
    jmp     scan4rdata
found_rdata_section:
    sub     ebx, [eax+14h]
    mov     dword ptr [rdata_va_offset], ebx
    sub     dword ptr [import_ptr], ebx ; import_ptr == RAW offset to image_import_descriptors
    mov     edx, [eax+0Ch]              ; rva
    mov     ebx, [eax+10h]
    mov     ecx, [eax+14h]              ; raw offset
    mov     [rdata_rva], edx
    mov     [rdata_size], ebx
    mov     [rdata_offset], ecx
    
    mov     eax, [decrypt_key]
    rol     eax, 8      ; get highest 8 bits into al
    xor     al, 0abh    ; xor with 'AB' to get asciiz decrypt key
    mov     [asciiz_key], al
    
decrypt_asciiz_and_firstthunk:
    lea     ebp, api_ptrs


    mov     ebx, [memory_ptr]
    mov     edx, [import_ptr]
    add     edx, ebx
    sub     ebx, [rdata_va_offset]

next_iid:
    mov     eax, [edx]              ; yak yak yak, edx -> image_import_descriptors
    or      eax, [edx+0Ch]
    jne     scan4k32_or_u32         ; jne were not on the NULL terminator of the iid's
    popad
    ret


scan4k32_or_u32:
    mov esi, [edx]          ; ptr to original_first_thunk
    add esi, ebx            ; add fixed memptr to it
    cmp dword ptr [esi], 0  ; first entry null?
    jne try_next_iid
    
correct_iid:
    mov eax, [temp_ptr]
    mov [eax], edx
    add eax, 4
    mov [temp_ptr], eax
    
    mov eax, [ebp]          ; load missing pointer into eax..
    add ebp, 4
    mov [esi], eax          ; stamp missing pointer over NULL
    xor ecx, ecx
    xor eax, eax
 daz_count_ptrs:
    cmp [ecx*4+esi], eax
    jz daz_counted_ptrs
    inc ecx
    jmp daz_count_ptrs
daz_counted_ptrs:
    mov [counter1], ecx
    mov [counter2], eax

    pushad
    push offset decrypt_key
    push ecx
    push esi
    call decrypt_thunk_2A200
    add esp, 0ch
    popad
    
; 1002A200 sub_1002A200  decrypt thunk???

next_asciiz_pointer:
    mov edi, [esi]
    or edi, edi
    jne more_asciiz_2_decrypt

try_next_iid:
    add edx, 14h
    jmp next_iid

more_asciiz_2_decrypt:
    add esi, 4
    add edi, ebx                ; edi -> asciiz now
    pushad
    movzx ecx, byte ptr [edi]
    mov word ptr [edi], 0       ; NULL the 'hint'
    add edi, 2
    push offset decrypt_key
    push ecx
    push edi
    call asciiz_decrypt_10029CD0
    add esp, 0ch
    popad
    jmp next_asciiz_pointer

;00D1274A                 push    ecx             ; ptr to tea key
;00D1274B                 mov     edx, [ebp+size_of_asciiz]
;00D1274E                 push    edx
;00D1274F                 mov     eax, [ebp+ptr_asciiz]
;00D12752                 push    eax
;00D12753                 call    freaky_decrypt_proc_uses_tea_cf8750


    mov word ptr [edi], 0       ; NULL the 'hint'
    add edi, 2
    mov cl, [asciiz_key]
decrypt_asciiz_loop:            ; decrypt the asciiz
    mov al, byte ptr [edi]
    mov ch, al
    xor al, cl
    mov byte ptr [edi], al
    je next_asciiz_pointer
    mov cl, ch
    inc edi
    jmp decrypt_asciiz_loop 


decrypt_mangled_api:
    pushad
    mov     eax, [memory_ptr]

    lea     edi, api_ptr_inf

dma_get_next_iid:
    mov     esi, [edi]     ; edi points to image_import_descriptor
    test    esi, esi
    jne     demangle_this_thunk
    call    fix_orig_thunk
    popad
    ret

demangle_next_iid:
    add     edi, 4
    jmp     dma_get_next_iid


demangle_this_thunk:
    mov ebx, [esi]
    sub ebx, [rdata_va_offset]
    add ebx, eax
    mov [de_thunk_ptr], ebx
    xor edx, edx

dma_count_api_pointers:
    inc edx
    cmp dword ptr [ebx+4*edx], 00000000
    jne dma_count_api_pointers
    mov [api_counter], edx
    call dm_build_and_sort_table
    call dm_use_table_to_sort_thunk
    jmp demangle_next_iid


dm_build_and_sort_table:
    pushad
    xor ebp, ebp
    xor edx, edx
    mov esi, [api_counter]
    mov eax, esi
    
dm_count_bits:
    inc edx
    shr eax, 1
    jne dm_count_bits       ; count BIT's in 'api counter'
    mov [dm_bit_counter], edx
    mov edi, [decrypt_key]
    lea ebx, demanglebuffer1
    xor eax, eax

dm_build_table:             ; build a table of ascending dwords, the size of the amount of pointers
    mov [ebx+4*eax], eax
    inc eax
    cmp eax, esi            ; cmp current_no, max_no
    jb dm_build_table       ; jb carry_on_building_table

dm_pseudo_sort:             ; sort the table into the correct order, using
    imul edi, 35E85A6Dh     ; these two consts, and morphing the decrypt key with them
    add edi, 361962E9h
    mov edx, [dm_bit_counter]
    mov ecx, edx            ; copy bit counter
    mov eax, edi            ; copy result of maths
    shr eax, cl             ; shift result right x bits
    mov ecx, 20h            ; 20h, 32 bits ;)
    sub ecx, edx            ; sub 32 off bit counter
    imul eax, esi           ; imul shifted_result, api_pointer_count
    shr eax, cl             ; haha, shift again
    cmp eax, ebp            ; cmp result_from_maths, current_pointer
    je dm_skip_swap         ; jz dont_sort :p
    push dword ptr [ebx+4*ebp]      ; push current pointer
    mov edx, [ebx+4*eax]            ; edx=pointer that maths gave us
    mov [ebx+4*ebp] , edx           ; and swap them around
    pop dword ptr [ebx+4*eax]       ;)

dm_skip_swap:
    inc ebp
    cmp ebp, esi
    jb dm_pseudo_sort
    popad
    ret


dm_use_table_to_sort_thunk:
    pushad   
    xor eax, eax
    mov esi, [de_thunk_ptr]
    lea edi, demanglebuffer2
    mov ecx, [api_counter]
    repz movsd
    lea esi, demanglebuffer1
    mov edi, [de_thunk_ptr]

demangle_l6:
    xor ebp, ebp

demangle_l7:
    cmp eax, dword ptr [esi+4*ebp]
    je demangle_l8
    inc ebp
    jmp demangle_l7

demangle_l8:
    mov ecx, dword ptr [edi+4*ebp]
    mov [4*eax+offset demanglebuffer2], ecx
    inc eax
    cmp eax, [api_counter]
    jb demangle_l6
    lea esi, demanglebuffer2
    mov ecx, [api_counter]
    repz movsd
    popad
    ret


fix_orig_thunk: ; copy fixed first thunk, over original first thunk, thus, fixing it
    pushad
    xor     ebp, ebp
    xor     ecx, ecx
    mov     ebx, [memory_ptr]
    lea     edx, api_ptr_inf
    
    sub     ebx, [rdata_va_offset]

flt_scan4last_iid:
    mov     eax, [edx]          ; edx points to wrapped image_import_descriptor array
    test    eax, eax
    jne     flt_this_iid        ; jump if not equal to fix_last_thunk_check_for_kernel_or_user
    popad
    ret


flt_this_iid:
    mov     esi, [eax]                  ; ptr to original first thunk
    add     esi, ebx
    mov     edi, [eax+10h]              ; ptr to 'fixed' first thunk
    mov     [begin_thunk+ecx], edi      ; data we require for 'fixing' code section
    add     edi, ebx

flt_copy_thunk:
    mov     eax, [esi]
    mov     dword ptr [edi], eax        ; copy first thunk pointers into original first thunk
    add     esi, 4
    add     edi, 4
    or      eax, eax
    jne     flt_copy_thunk
    sub     edi, ebx
    sub     edi, 4
    mov     [end_thunk+ecx], edi        ; data we require for 'fixing' code section
    add     ecx, 4
    add     edx, 4
    jmp     flt_scan4last_iid

rand proc stdcall integer:DWORD
    pushad
    mov eax, [seed]
    rol eax, 3
    mov cl, al
    xor edx, edx
    div integer
    add [seed], eax
    add [seed], 425534
    mov [esp+1ch], edx
    rol edx, cl
    xor [seed], edx
    popad
    ret

rand endp

.data

seed dd 12345678h

fileout_sdv2        db  'sdv2.testme.exe',0
fileout_sdv2_dll    db  'sdv2.testme.dll',0


err_icd_open    db  'Cannot open file!',0
err_pe_struct   db  'Bad pe structure (delete it!)',0
err_mem_alloc   db  'Cannot allocate memory!',0
err_read_icd    db  'Cannot read from encrypted file',0
err_rand_err    db  'random error :-)',0
err_jmp_err     db  'stxt774 api jmp thingy error, get in touch with r!sc',0
err_jmp_warning db  'stxt774 api jmp thingy error, friendly warning',0

boxfilter   db  'all files (*.*)',0,'*.*',0,'Safedisc v2 dumped files (*.bin)',0,'*.bin',0,0
titlebox    db  'cant beat the system, go with the flow',0
ofn     dd  04ch,0,0,boxfilter,0,0,0
        dd  icd_name
        dw  0100h,0
        dd  0,0,0,titlebox,01000h
        dd  0,0,0,0,0


error       db  0

asciiz_key  db 0

ptr_to_decrypt_key  dd offset decrypt_key

align 4

icd_name    db 100h dup (?)

decrypt_key     dd 4 dup (?)
                dd 100h dup (?) ; 1024 byte decrypt key
raxs_proc       db 120h*2 dup (?)   ; api raxs proc (fix_calls)
api_ptrs        dd 10h dup (?)      ; missing api ptrs from each thunk
jmp_array       dd 100h dup (?)     ; :p
stxt774_inf     dd 100h dup (?)     ; bunch of pointers into stxt774 section, used in api unwrapper
lib_id_ptr      dd  ?               ; woohoo

    dd  10 dup (?)

re_temp_offset  dd ?
stxt774_rva     dd ?
stxt774_vsize   dd ?
stxt774_offset  dd ?
memory_ptr      dd ?
memory_size     dd ?
pe_sections     dd ?
sections_ptr    dd ?
pe_image_base   dd ?
icd_entrypoint  dd ?
icd_size        dd ?
pe_header_ptr   dd ?
filehandle      dd ?
bytesrw         dd ?

import_ptr      dd ?
rdata_va_offset dd ?
rdata_rva       dd ?
rdata_size      dd ?
rdata_offset    dd ?

temp_lib_id     dd ?

de_thunk_ptr    dd ?   ; thunk array pointer used in demangle routine
api_counter     dd ?   ; used to count how many api's need to be fixed
dm_bit_counter  dd ?   ;

demanglebuffer1 db  4000h dup (?)
demanglebuffer2 db  4000h dup (?)

begin_thunk  dd  10h dup (?)  ; info for 'fixing' code section
end_thunk    dd  10h dup (?)  ;


temp_ptr    dd  ?
temp_eax    dd  ?

api_ptr_inf dd  10h dup (?)
counter1    dd  ?
counter2    dd  ?

lib_id      dd 40h dup (?)

end main